/*
For information on this software or to report bugs please visit http://www.ranton.org
or email ranton@ranton.org

For custom software development and consulting please visit http://www.madlogic.com .

Copyright (c) 2003, Richard Neal Anton
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

*	Redistributions of source code must retain the above copyright notice, this list
	of conditions and the following disclaimer. 

*	Redistributions in binary form must reproduce the above copyright notice, this list
	of conditions and the following disclaimer in the documentation and/or other materials
	provided with the distribution. 

*	The name of the copyright holder may not be used to endorse or promote products 
	derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __IMAGIZEAPP__
#define __IMAGIZEAPP__


#ifndef __WBMP__
#include "WBmp.h"
#endif
	

#include <windows.h>

class ImagizeApp {
public:
	ImagizeApp(void);
	~ImagizeApp();

	// initialize
	void Init(HINSTANCE inInstance);

	// run
	void Run(void);

	 // call when size of main window changed.
	void SizeChanged(void);

	// open bitmap from file
	void Open(void);

	// save bitmap to file
	void Save(void);

	// set transform to identity.
	void Identity(void);

	// zoom in and out
	void ZoomIn(void);
	void ZoomOut(void);

	// rotate
	void Clockwise(void);
	void CClockwise(void);

	// skew
	void Taller(void);
	void Wider(void);

	// this blits the bitmap to the screen.
	void Draw(void);

	// show about box
	void About(void);

	// these handle dragging of the image
	void StartDragging(int mx, int my);
	void StopDragging(int mx, int my);
	void KeepDragging(int mx, int my);

	static ImagizeApp *GetApp(void) { return sApp; }

protected:
	bool Start(void); // called by Run

	// transform mOrigBitmap into mBitmap
	void Transform(void);

protected:
	static ImagizeApp *sApp;

	HINSTANCE mInstance;
	HWND mMainWindow, mMainDlg, mBitmapWindow;
	RECT mBitmapOffsets;
	HACCEL mAccel;

	WBmp mBitmap, mOrigBitmap;

	bool mDragging;
	int mDragLastX, mDragLastY;

	double mTranslateX, mTranslateY;
	double mScaleX, mScaleY;
	double mRotateAngle;

};


#endif

